function Create(self)

	self.lifeTimer = Timer();

	self.raylength = 20;
	self.rayPixSpace = 1;

	self.dots = math.floor(self.raylength/self.rayPixSpace);

end

function Update(self)

	self.raylength = self.Vel.Magnitude;
	self.dots = math.floor(self.raylength/self.rayPixSpace);

	for i = 1, self.dots do
		local checkPos = self.Pos + Vector(self.Vel.X,self.Vel.Y):SetMagnitude((i/self.dots)*self.raylength);
		if SceneMan.SceneWrapsX == true then
			if checkPos.X > SceneMan.SceneWidth then
				checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
			elseif checkPos.X < 0 then
				checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
			end
		end
		local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
		if terrCheck == 0 then
			local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
			if moCheck ~= 255 then
				local actor = MovableMan:GetMOFromID( MovableMan:GetMOFromID(moCheck).RootID );
				if actor.Team ~= self.Team then
					self:GibThis();
				end
			end
		else
			self:GibThis();
		end
	end
	
	if self.lifeTimer:IsPastSimTimeLimit() then
		self:GibThis();
	end

	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
	
	-- smoke trail
	local trailLength = math.floor(Offset.Magnitude+0.5)
	for i = 1, trailLength, 6 do
		Effect = CreateMOSParticle("Sniper Smoke Trail " .. math.random(3), "RCSA.rte")
		if Effect then
			Effect.Pos = self.Pos - Offset * (i/trailLength) + Vector(RangeRand(-2, 2), RangeRand(-2, 2))
			Effect.Vel = self.Vel * RangeRand(0.9, 1.0)
			MovableMan:AddParticle(Effect)
		end
	end
end
