

function Create(self)
	self.v1 = 30;
	self.v2 = 20;
	self.vtime = 500;
	self.vstep = (self.v1-self.v2)/(0.005*self.vtime);
	self.vtimer = Timer();
	
	self.InterceptVel = self.v1;
	self.MaxRange = 1250;
	self.Accuracy = 12;
	
	self.ok = false;
	self:EnableEmission(false);
	
	self.Target = MovableMan:GetMOFromID(math.ceil(self.Mass));
	self.Mass = 2.5;
	self.RotAngle = math.pi/2;
--The missile's target, currently set to nothing.

    self.target = nil;

--Find out who shot the weapon by finding the closest actor within 100 pixels.
    local curdist = 100;
    for actor in MovableMan.Actors do
	local avgx = actor.Pos.X - self.Pos.X;
	local avgy = actor.Pos.Y - self.Pos.Y;
	local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
	if dist < curdist and actor.ClassName ~= "ADoor" then
	    curdist = dist;
	    self.parent = actor;
	end
    end

--If the missile has no firer, make it go after anyone.  Otherwise, set its team to that of the firer.
    if MovableMan:IsActor(self.parent) then
	self.Team = self.parent.Team;
    else
	self.Team = -1;
    end
end

function Destroy(self)
end

function Update(self)


if self.Age > 400 and self.Target ~= nil and MovableMan:IsActor(self.Target) then
	self.HitsMOs = true;
				
				if self.InterceptVel >= (self.v2+self.vstep) and self.vtimer:IsPastSimMS(50) then
					self.vtimer:Reset();
					self.InterceptVel = self.InterceptVel - self.vstep;
				end
				
				local d = SceneMan:ShortestDistance(self.Pos, self.Target.Pos, true).Magnitude;
				self.ok = true;
				local tps = d/self.InterceptVel;
				local pc = self.Target.Pos;
				local idv;
				local id;

				local i = 0;
				while i<self.Accuracy do
				    pc = self.Target.Pos + self.Target.Vel*tps;
				    idv = Vector(pc.X - self.Pos.X, pc.Y - self.Pos.Y);
				    id = idv.Magnitude;
				    
				    tps = id/self.InterceptVel;
				    i = i+1;
				end

						
				
				local idx = -SceneMan:ShortestDistance(pc, self.Pos, true).X;
				local idy = -SceneMan:ShortestDistance(pc, self.Pos, true).Y;
				local t = math.abs(idy/idx);

				local a = math.atan(t);

				self:EnableEmission(true);
				
    			if idx < 0 then
    				self.Vel.X = -math.cos(a)*self.InterceptVel;
				else
				    self.Vel.X = math.cos(a)*self.InterceptVel;
				end
				if idy < 0 then
					self.Vel.Y = -math.sin(a)*self.InterceptVel;
				else
					self.Vel.Y = math.sin(a)*self.InterceptVel;
				end
				
				local tdist = SceneMan:ShortestDistance(self.Pos, pc, true).Magnitude;
				local ray0 = SceneMan:CastObstacleRay(self.Pos, Vector(0.5*self.Vel.X,25), Vector(), Vector(), self.ID, -6, 128, 2);
				local ray1 = SceneMan:CastObstacleRay(self.Pos, Vector(0.5*self.Vel.X,-25), Vector(), Vector(), self.ID, -6, 128, 2);
				local ray2 = SceneMan:CastObstacleRay(self.Pos, Vector(self.Vel.X,25), Vector(), Vector(), self.ID, -6, 128, 2);
				local ray3 = SceneMan:CastObstacleRay(self.Pos, Vector(self.Vel.X,-25), Vector(), Vector(), self.ID, -6, 128, 2);
				local ray4;
				local ray5;
				if ray0 > ray2 then
					ray4 = ray0;
				else
					ray4 = ray2;
				end
				if ray1 > ray3 then
					ray5 = ray1;
				else
					ray5 = ray3;
				end
				if tdist > 125 and ( ray2 > 0 or ray0 > 0) then
					self.Vel.Y = self.Vel.Y - (30-(ray4/2.5));
				end
				if tdist > 125 and (ray3 > 0 or ray1 > 0) then
					self.Vel.Y = self.Vel.Y + (30-(ray5/2.5));
				end
				
end
	


if self.ok == false and self.Age > 1000 then
	self.ToDelete = true;
	self.M = CreateAEmitter("Missile Deactivated","MPW.rte");
    self.M.Pos = self.Pos;
    self.M.Vel = self.Vel;
	MovableMan:AddMO(self.M);
	self.M:GibThis();
end

	local ray = SceneMan:CastObstacleRay(self.Pos , self.Vel*3*TimerMan.DeltaTimeSecs*GetPPM() , Vector() , Vector() , self.ID, -6 , 0 , 1);
	if ray > 0 or self.ToDelete == true then
		self:GibThis();
	end	

	
end